#include <jendefs.h>
#include <AppHardwareApi.h>

#include "pwm.h"

uint8_t timer[MAX_TIMER] = {E_AHI_TIMER_0,
									 E_AHI_TIMER_1,
									 E_AHI_TIMER_2,
									 E_AHI_TIMER_3,
									 E_AHI_TIMER_4};
void pwmInit(uint8_t t)
{
	vAHI_TimerDIOControl(timer[t], TRUE);

	vAHI_TimerEnable(
		timer[t], 		//Timer ID
		4,					//Prescaler = 2^4 
		FALSE,			//IntRiseEnable
		FALSE,			//IntPeriodEnable
		TRUE				//OutputEnable
		);
	vAHI_TimerConfigureOutputs(
		timer[t],		//Timer ID
		TRUE,				//PwmOutputInvertEnable
		TRUE				//GateDisable
		);

}

void pwmCreate(uint8_t amt)
{
	switch (amt)
	{
		case MAX_TIMER:
			pwmInit(MAX_TIMER-1);	
		
		case MAX_TIMER-1:
			pwmInit(MAX_TIMER-2);	
		
		case MAX_TIMER-2:
			pwmInit(MAX_TIMER-3);

		case MAX_TIMER-3:
			pwmInit(MAX_TIMER-4);

		case MAX_TIMER-4:
			pwmInit(MAX_TIMER-5);

		default:
			break;
	}
}

void pwmStart(uint8_t t,uint16_t high, uint16_t period, uint8_t mode)
{
	if(mode == ONESHOT)
	{
		vAHI_TimerStartSingleShot(timer[t],	//Timer ID
									 high,		//High Period
									 period		//Time Period 
									 );
	}
	
	else if(mode == PERIODIC)
	{
		vAHI_TimerStartRepeat(timer[t],	//Timer ID
									 high,		//High Period
									 period		//Time Period 
									 );
	}
}

void pwmStop(uint8_t t)
{
	vAHI_TimerStop(timer[t]);
}
